<?

global $DIC,$REGEX,$REG,$USER_REG,$USER_REGEX;

$USER_REG = array();
$USER_REGEX = array();

function get_user_regs() {
 global $LANGUAGE,$USER_REG,$USER_REGEX,$SQLAS;

 
 $sql = "SELECT regex.id, regex.regex, n_dic.value as name, d_dic.value as descr FROM dicuser $SQLAS n_dic, dicuser $SQLAS d_dic, regex WHERE (regex.name_id = n_dic.output_id AND n_dic.language_id = ".sqlf_tl_num($LANGUAGE).") AND (regex.desc_id = d_dic.output_id AND d_dic.language_id = ".sqlf_tl_num($LANGUAGE).")";

 $rs = query($sql);

 if ($rs["arr"]) {
 while (list($key,$row) = each($rs["arr"])) {
 $USER_REG[$row["id"]]["exp"] = $row["regex"];
 $USER_REGEX[$row["id"]] = $row["regex"];
 $USER_REG[$row["id"]]["name"] = $row["name"];
 $USER_REG[$row["id"]]["desc"] = $row["descr"];
 }
 }
 return $USER_REG;
}

function get_regex_by_id($regex_id) {
 $sql = "SELECT regex from regex where id = ".sqlf_tl_num($regex_id);

 $rs = query($sql);
 return $rs['arr'][0]['regex'];
}

function get_regex_description($regex_id) {
 global $LANGUAGE;

 $sql = "SELECT d1.value name, d2.value description
          FROM regex
          LEFT JOIN dicuser d1 ON d1.output_id = regex.name_id AND d1.language_id = ".sqlf_tl_num($LANGUAGE)."
          LEFT JOIN dicuser d2 ON d2.output_id = regex.desc_id AND d2.language_id = ".sqlf_tl_num($LANGUAGE)."
          WHERE regex.id = ".sqlf_tl_num($regex_id);

 $rs = query($sql);
 $ret = $rs['arr'][0]['name'].": ".$rs['arr'][0]['description'];
 return $ret;
}


$REGEX = array();
$REG = array();


define( "REG_INTEGER", 1 );
$REGEX[1] = "^[1-9][0-9]{0,8}$";
$REG[1]["exp"] = "^[1-9][0-9]{0,8}$";
$REG[1]["name"] = $DIC[1126];
$REG[1]["desc"] = $DIC[1127];

define( "REG_EMAIL", 4 );
$REGEX[4] = "^([-_.&0-9a-zA-Z\+])+@[0-9a-z]([-.]?[0-9a-z])*.[a-z]{2,}$";
$REG[4]["exp"] = "^([-_.&0-9a-zA-Z\+])+@[0-9a-z]([-.]?[0-9a-z])*.[a-z]{2,}$";
$REG[4]["name"] = $DIC[1128];
$REG[4]["desc"] = $DIC[1129];

define( "REG_NOTEMPTY", 5 );
$REGEX[5] = ".+";
$REG[5]["exp"] = ".+";
$REG[5]["name"] = $DIC[1130];
$REG[5]["desc"] = $DIC[1131];

define( "REG_TEXT_SHORT", 8 );
$REGEX[8] = "^.{1,255}$";
$REG[8]["exp"] = "^.{1,255}$";
$REG[8]["name"] = $DIC[1132];
$REG[8]["desc"] = $DIC[1133];

define( "REG_TEXT", 9 );
$REGEX[9] = "";
$REG[9]["exp"] = "";
$REG[9]["name"] = $DIC[1134];
$REG[9]["desc"] = $DIC[1135];

define( "REG_FLOAT", 10 );
$REGEX[10] = "^[-+]{0,1}[0-9]{1,9}.{0,1}[0-9]{0,2}$";
$REG[10]["exp"] = "^[-+]{0,1}[0-9]{1,9}.{0,1}[0-9]{0,2}$";
$REG[10]["name"] = $DIC[1136];
$REG[10]["desc"] = $DIC[1137];

define( "REG_TEXT_SIMPLE", 11 );
$REGEX[11] = "^[ßäöüÄÖÜa-zA-Z .-]{1,50}$";
$REG[11]["exp"] = "^[ßäöüÄÖÜa-zA-Z .-]{1,50}$";
$REG[11]["name"] = $DIC[1138];
$REG[11]["desc"] = $DIC[1139];

define( "REG_LONG", 12 );
$REGEX[12] = "^[+-]{0,1}[0-9]{1,9}$";
$REG[12]["exp"] = "^[+-]{0,1}[0-9]{1,9}$";
$REG[12]["name"] = $DIC[1140];
$REG[12]["desc"] = $DIC[1141];
global $CUSTOM_LOGIN_REGEX;

define( "REG_TEXT_RESTRICTED", 13 );
if (is_array($CUSTOM_LOGIN_REGEX)) {
 $REG[13] = $CUSTOM_LOGIN_REGEX;
 if (!$REG[13]["name"]) $REG[13]["name"] = $DIC[1142];
} else {
 $REG[13]["exp"] = "^[a-zA-Z0-9\._@\+\-]{4,40}$";
 $REG[13]["name"] = $DIC[1142];
 $REG[13]["desc"] = $DIC[1143];
}
$REGEX[13] = $REG[13]["exp"];

global $CUSTOM_PASSWORD_REGEX;
define( "REG_TEXT_PASSWORD", 14 );
if (is_array($CUSTOM_PASSWORD_REGEX)) {
 $REG[14] = $CUSTOM_PASSWORD_REGEX;
 if (!$REG[14]["name"]) $REG[14]["name"] = $DIC[1142];
} else {
 $REG[14]["exp"] = "^[a-zA-Z0-9\._@\+\-]{4,40}$";
 $REG[14]["name"] = $DIC[1142];
 $REG[14]["desc"] = $DIC[1143];
}
$REGEX[14] = $REG[14]["exp"];

define( "REG_URL", 15 );
$REGEX[15] = ".+";
$REG[15]["exp"] = ".+";
$REG[15]["name"] = $DIC[1144];
$REG[15]["desc"] = $DIC[1145];

$REGEX[16] = "^[a-zA-Z0-9\._-]{1,64}$";
$REG[16]["exp"] = "^[a-zA-Z0-9\._-]{1,64}$";



define( "REG_FOLDERNAME", 17 );
$REGEX[17] = "^[0-9ßäöüÄÖÜa-zA-Z \.-]{1,255}$";
$REG[17]["exp"] = "^[0-9ßäöüÄÖÜa-zA-Z \.-]{1,255}$";
$REG[17]["name"] = $DIC[1146];
$REG[17]["desc"] = $DIC[1147];

define( "REG_FILENAME", 18 );
$REGEX[18] = "^[a-zA-Z0-9._-]{1,64}$";
$REG[18]["exp"] = "^[a-zA-Z0-9._-]{1,64}$";
$REG[18]["name"] = $DIC[1148];
$REG[18]["desc"] = $DIC[1149];

define( "REG_DATE", 19 );
$REGEX[19] = "^([0-9]{1,2})[.,_/ -]([0-9]{1,2})[.,_/ -]([0-9]{2}|[0-9]{4})$";
$REG[19]["exp"] = "^([0-9]{1,2})[.,_/ -]([0-9]{1,2})[.,_/ -]([0-9]{2}|[0-9]{4})$";
$REG[19]["name"] = $DIC[1150];
$REG[19]["desc"] = $DIC[1151];

define( "REG_TIME", 20 );
$REGEX[20] = "^([0-9]{1,2}):([0-9]{1,2})$";
$REG[20]["exp"] = "^([0-9]{1,2}):([0-9]{1,2})$";
$REG[20]["name"] = $DIC[1152];
$REG[20]["desc"] = $DIC[1153];

define( "REG_TIME_ALT", 21 );
$REGEX[21] = "^([0-1]?[0-9]|2[0-3])(:([0-5]?[0-9])|())$";
$REG[21]["exp"] = "^([0-1]?[0-9]|2[0-3])(:([0-5]?[0-9])|())$";
$REG[21]["name"] = $DIC[1154];
$REG[21]["desc"] = $DIC[1155];

define( "REG_SHORT", 22 );
$REGEX[22] = "^[1-5]{0,1}[0-9]$";
$REG[22]["exp"] = "^[1-5]{0,1}[0-9]$";
$REG[22]["name"] = $DIC[1156];
$REG[22]["desc"] = $DIC[1157];

define( "REG_DATE_ALT", 23 );
$REGEX[23] = "^([0-2]?[0-9]|3[0-1])([.:_ /-]([0]?[0-9]|1[0-2])([.:_ /-]([0-9]{1,2}|[0-9]{4})|[.:_ /-]|())|[.:_ /-]|())$";
$REG[23]["exp"] = "^([0-2]?[0-9]|3[0-1])([.:_ /-]([0]?[0-9]|1[0-2])([.:_ /-]([0-9]{1,2}|[0-9]{4})|[.:_ /-]|())|[.:_ /-]|())$";
$REG[23]["name"] = $DIC[1158];
$REG[23]["desc"] = $DIC[1159];

define( "REG_PATH", 24 );
$REGEX[24] = "^/{0,1}([a-zA-Z0-9\._-]{1,64}/{0,1}){0,127}$";
$REG[24]["exp"] = "^/{0,1}([a-zA-Z0-9\._-]{1,64}/{0,1}){0,127}$";
$REG[24]["name"] = $DIC[1160];
$REG[24]["desc"] = $DIC[1161];

define( "REG_HOSTNAME", 25 );
$REGEX[25] = "^[0-9a-z]([-.]?[0-9a-z:])*$";
$REG[25]["exp"] = "^[0-9a-z]([-.]?[0-9a-z:])*$";
$REG[25]["name"] = $DIC[1162];
$REG[25]["desc"] = $DIC[1163];

define( "REG_TEXT_UNIQUE", 26 );
$REGEX[26] = "^[a-z0-9]{3,64}$";
$REG[26]["exp"] = "^[a-z0-9]{3,64}$";
$REG[26]["name"] = $DIC[1164];
$REG[26]["desc"] = $DIC[1165];

define( "REG_PLZ", 27 );
$REGEX[27] = "[A-Z]{0,2}[\-]{0,1}[0-9]{4,6}";
$REG[27]["exp"] = "[A-Z]{0,2}[\-]{0,1}[0-9]{4,6}";
$REG[27]["name"] = $DIC[1166];


define( "REG_PHONE", 28 );
$REGEX[28] = "^[0-9\-\/ \+\(\)]{4,25}$";
$REG[28]["exp"] = "^[0-9\-\/ \+\(\)]{4,25}$";
$REG[28]["name"] = $DIC[1167];
$REG[28]["desc"] = $DIC[1168];

define( "REG_PRICE", 29 );
$REGEX[29] = "^[0-9]{1,12}.{0,1}[0-9]{0,2}$";
$REG[29]["exp"] = "^[0-9]{1,12}.{0,1}[0-9]{0,2}$";
$REG[29]["name"] = $DIC[1169];
$REG[29]["desc"] = $DIC[1170];

define( "REG_FILESHARE", 30 );
$REGEX[30] = "^\\\\.*$";
$REG[30]["exp"] = "^\\\\.*$";
$REG[30]["name"] = $DIC[1171];
$REG[30]["desc"] = $DIC[1172];

define( "REG_NODETAG", 31 );
$REGEX[31] = "^[a-zA-Z0-9\_\-]{3,255}$";
$REG[31]["exp"] = "^[a-zA-Z0-9\_\-]{3,255}$";
$REG[31]["name"] = $DIC[1173];
$REG[31]["desc"] = $DIC[1174];


$REGEX[40] = "(?:http://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?)(?:/(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;:@&=])*)(?:/(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;:@&=])*))*)(?:\?(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;:@&=])*))?)?)|(?:ftp://(?:(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;?&=])*)(?::(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;?&=])*))?@)?(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?))(?:/(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[?:@&=])*)(?:/(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[?:@&=])*))*)(?:;type=[AIDaid])?)?)|(?:news:(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;/?:&=])+@(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3})))|(?:[a-zA-Z](?:[a-zA-Z\d]|[_.+-])*)|\*))|(?:nntp://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?)/(?:[a-zA-Z](?:[a-zA-Z\d]|[_.+-])*)(?:/(?:\d+))?)|(?:telnet://(?:(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;?&=])*)(?::(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;?&=])*))?@)?(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?))/?)|(?:gopher://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?)(?:/(?:[a-zA-Z\d$\-_.+!*'(),;/?:@&=]|(?:%[a-fA-F\d]{2}))(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),;/?:@&=]|(?:%[a-fA-F\d]{2}))*)(?:%09(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;:@&=])*)(?:%09(?:(?:[a-zA-Z\d$\-_.+!*'(),;/?:@&=]|(?:%[a-fA-F\d]{2}))*))?)?)?)?)|(?:wais://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?)/(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))*)(?:(?:/(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))*)/(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))*))|\?(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;:@&=])*))?)|(?:mailto:(?:(?:[a-zA-Z\d$\-_.+!*'(),;/?:@&=]|(?:%[a-fA-F\d]{2}))+))|(?:file://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))|localhost)?/(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[?:@&=])*)(?:/(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[?:@&=])*))*))|(?:prospero://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?)/(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[?:@&=])*)(?:/(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[?:@&=])*))*)(?:(?:;(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[?:@&])*)=(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[?:@&])*)))*)|(?:ldap://(?:(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?))?/(?:(?:(?:(?:(?:(?:(?:[a-zA-Z\d]|%(?:3\d|[46][a-fA-F\d]|[57][Aa\d]))|(?:%20))+|(?:OID|oid)\.(?:(?:\d+)(?:\.(?:\d+))*))(?:(?:%0[Aa])?(?:%20)*)=(?:(?:%0[Aa])?(?:%20)*))?(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))*))(?:(?:(?:%0[Aa])?(?:%20)*)\+(?:(?:%0[Aa])?(?:%20)*)(?:(?:(?:(?:(?:[a-zA-Z\d]|%(?:3\d|[46][a-fA-F\d]|[57][Aa\d]))|(?:%20))+|(?:OID|oid)\.(?:(?:\d+)(?:\.(?:\d+))*))(?:(?:%0[Aa])?(?:%20)*)=(?:(?:%0[Aa])?(?:%20)*))?(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))*)))*)(?:(?:(?:(?:%0[Aa])?(?:%20)*)(?:[;,])(?:(?:%0[Aa])?(?:%20)*))(?:(?:(?:(?:(?:(?:[a-zA-Z\d]|%(?:3\d|[46][a-fA-F\d]|[57][Aa\d]))|(?:%20))+|(?:OID|oid)\.(?:(?:\d+)(?:\.(?:\d+))*))(?:(?:%0[Aa])?(?:%20)*)=(?:(?:%0[Aa])?(?:%20)*))?(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))*))(?:(?:(?:%0[Aa])?(?:%20)*)\+(?:(?:%0[Aa])?(?:%20)*)(?:(?:(?:(?:(?:[a-zA-Z\d]|%(?:3\d|[46][a-fA-F\d]|[57][Aa\d]))|(?:%20))+|(?:OID|oid)\.(?:(?:\d+)(?:\.(?:\d+))*))(?:(?:%0[Aa])?(?:%20)*)=(?:(?:%0[Aa])?(?:%20)*))?(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))*)))*))*(?:(?:(?:%0[Aa])?(?:%20)*)(?:[;,])(?:(?:%0[Aa])?(?:%20)*))?)(?:\?(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))+)(?:,(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))+))*)?)(?:\?(?:base|one|sub)(?:\?(?:((?:[a-zA-Z\d$\-_.+!*'(),;/?:@&=]|(?:%[a-fA-F\d]{2}))+)))?)?)?)|(?:(?:z39\.50[rs])://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?)(?:/(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))+)(?:\+(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))+))*(?:\?(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))+))?)?(?:;esn=(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))+))?(?:;rs=(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))+)(?:\+(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))+))*)?))|(?:cid:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;?:@&=])*))|(?:mid:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;?:@&=])*)(?:/(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;?:@&=])*))?)|(?:vemmi://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?)(?:/(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[/?:@&=])*)(?:(?:;(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[/?:@&])*)=(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[/?:@&])*))*))?)|(?:imap://(?:(?:(?:(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~])+)(?:(?:;[Aa][Uu][Tt][Hh]=(?:\*|(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~])+))))?)|(?:(?:;[Aa][Uu][Tt][Hh]=(?:\*|(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~])+)))(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~])+))?))@)?(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?))/(?:(?:(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~:@/])+)?;[Tt][Yy][Pp][Ee]=(?:[Ll](?:[Ii][Ss][Tt]|[Ss][Uu][Bb])))|(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~:@/])+)(?:\?(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~:@/])+))?(?:(?:;[Uu][Ii][Dd][Vv][Aa][Ll][Ii][Dd][Ii][Tt][Yy]=(?:[1-9]\d*)))?)|(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~:@/])+)(?:(?:;[Uu][Ii][Dd][Vv][Aa][Ll][Ii][Dd][Ii][Tt][Yy]=(?:[1-9]\d*)))?(?:/;[Uu][Ii][Dd]=(?:[1-9]\d*))(?:(?:/;[Ss][Ee][Cc][Tt][Ii][Oo][Nn]=(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~:@/])+)))?)))?)|(?:nfs:(?:(?://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?)(?:(?:/(?:(?:(?:(?:(?:[a-zA-Z\d\$\-_.!~*'(),])|(?:%[a-fA-F\d]{2})|[:@&=+])*)(?:/(?:(?:(?:[a-zA-Z\d\$\-_.!~*'(),])|(?:%[a-fA-F\d]{2})|[:@&=+])*))*)?)))?)|(?:/(?:(?:(?:(?:(?:[a-zA-Z\d\$\-_.!~*'(),])|(?:%[a-fA-F\d]{2})|[:@&=+])*)(?:/(?:(?:(?:[a-zA-Z\d\$\-_.!~*'(),])|(?:%[a-fA-F\d]{2})|[:@&=+])*))*)?))|(?:(?:(?:(?:(?:[a-zA-Z\d\$\-_.!~*'(),])|(?:%[a-fA-F\d]{2})|[:@&=+])*)(?:/(?:(?:(?:[a-zA-Z\d\$\-_.!~*'(),])|(?:%[a-fA-F\d]{2})|[:@&=+])*))*)?)))";
$REG[40]["exp"] = $REGEX[40];
$REG[40]["name"] = "URLs";
$REG[40]["desc"] = "";

define( "REG_SHORT0", 41 );
$REGEX[41] = "^[0-5]{0,1}[0-9]$";
$REG[41]["exp"] = "^[0-5]{0,1}[0-9]$";
$REG[41]["name"] = $DIC[1156];
$REG[41]["desc"] = $DIC[2297];

define( "REG_SHORT0_VOID", 42 );
$REGEX[42] = "^([0-5]{0,1}[0-9])?$";
$REG[42]["exp"] = "^([0-5]{0,1}[0-9])?$";
$REG[42]["name"] = $DIC[1156];
$REG[42]["desc"] = $DIC[2297];

define( "REG_DATETIME", 43 );
$REGEX[43] = "^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}:[0-9]{2}$";
$REG[43]["exp"] = $REGEX[43];
$REG[43]["name"] = i18n("reg_datetime");
$REG[43]["desc"] = i18n("reg_datetime");
?>
