<?




function cmd_node_create($name,$host,$pub_dir,$description,$ftpsync,$ftphost,$ftplogin,$ftppassword,$ftpwwwroot,$utf8,$publish_fs = 1,$publish_contentmap = 1, $contentmap_handle = "", $disable_publish = 0, $editorversion = 0, $master_id = 0) {
 global $ERROR, $DIC, $TIME, $USER_ID, $T_DOMAIN, $W_CREATE, $T_FOLDER, $T_CONTENT, $T_DOMAIN_CHANNEL;

 
 if ($master_id < 0) {
 $master_id = 0;
 }

 if (!$name) {
 $ERROR = $DIC[855];
 return false;
 }

 if ($utf8) $utf8 = 1;
 else $utf8 = 0;
 
 if (!$editorversion) $editorversion = LIVEEDITOR;

 
 $anode = sqlslashes($name);
 $sql = "SELECT id FROM folder WHERE mother = 0 AND name = '$anode'";
 $rs = query($sql,1);
 if ($rs["num"] > 0) {
 $ERROR = $DIC[856];
 return false;
 }

 
 $name = sqlslashes($name);
 $description = sqlslashes($description);
 $pub_dir = sqlslashes($pub_dir);
 if (!$ftpsync) $ftpsync = 0;
 if (!$publish_fs) $publish_fs = 0;
 if (!$publish_contentmap) $publish_contentmap = 0;
 $ftphost = sqlslashes($ftphost);
 $ftplogin = sqlslashes($ftplogin);
 $ftppassword = sqlslashes($ftppassword);
 $ftpwwwroot = sqlslashes($ftpwwwroot);
 if ($ftpwwwroot[strlen($ftpwwwroot)-1] == "/") $ftpwwwroot = substr($ftpwwwroot,0,strlen($ftpwwwroot)-1);
 if(!$ftpwwwroot) $ftpwwwroot = ".";
 $contentmap_handle = sqlslashes($contentmap_handle);
 $disable_publish = intval($disable_publish);
 
 
 if ($pub_dir[strlen($pub_dir)-1] == "/") $pub_dir = substr($pub_dir,0,strlen($pub_dir)-1);
 if (strlen($pub_dir) > 0 && $pub_dir[0] != "/") $pub_dir = "/".$pub_dir;

 $host = sqlslashes($host);

 $sql = "INSERT INTO node (host,pub_dir,creator,cdate,editor,edate,ftpsync,ftphost,ftplogin,ftppassword,ftpwwwroot,publish_fs,publish_contentmap,contentmap_handle,utf8,disable_publish,editorversion) 
VALUES ('$host','".sqlf_escaped($pub_dir)."',".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",".sqlf_tl_num($ftpsync).",'".sqlf_escaped($ftphost)."','".sqlf_escaped($ftplogin)."','".sqlf_escaped($ftppassword)."','".sqlf_escaped($ftpwwwroot)."',".sqlf_tl_num($publish_fs).",".sqlf_tl_num($publish_contentmap).",'".sqlf_escaped($contentmap_handle)."',".sqlf_tl_num($utf8).",".sqlf_tl_num($disable_publish).",".sqlf_tl_num($editorversion).")";
 $rs = query($sql);
 $node_id = $rs["iid"];

 
 if (intval($master_id) == 0 || intval($master_id) == -9999) {
 $type_id = $T_DOMAIN;
 $channelset_id = 0;
 $channel_id = 0;
 $is_master = 1; 
 } else {
 $type_id = $T_DOMAIN_CHANNEL;
 node_class("cnfolder");
 $master = new CNFolderObject($master_id);
 $channelset_id = $master->getChannelsetId(true);
 $channel_id = $node_id;
 $is_master = 0; 
 }
 
 $sql = "INSERT INTO folder (name,description,creator,cdate,editor,edate,node_id,type_id,mother,pub_dir,master_id,channel_id,channelset_id,is_master) VALUES ".
 "('".sqlf_escaped($name)."','".sqlf_escaped($description)."',".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",".sqlf_tl_num($rs["iid"]).",".sqlf_tl_num($type_id).", 0, '/'," . sql_num($master_id) . ", ".sql_num($channel_id).", ".sql_num($channelset_id).", ".sql_num($is_master).")";
 $rs = query($sql);
 $folder_id = $rs["iid"];

 $sql = "UPDATE node SET folder_id = ".sqlf_tl_num($rs["iid"])." WHERE id = ".sqlf_tl_num($node_id);
 query($sql);

 
 perm_grant_all( $T_FOLDER, $folder_id );
 if (intval($master_id) == 0 || intval($master_id) == -9999) {
 perm_grant_all( $T_DOMAIN, $folder_id );
 } else {
 perm_grant_all( $T_DOMAIN_CHANNEL, $folder_id );
 }
 
 logcmd($W_CREATE,$T_DOMAIN,$folder_id,0,"cmd_node_create");

 return $node_id;
}

function cmd_node_update($folder_id,$name,$host,$pub_dir,$description,$ftpsync,$ftphost,$ftplogin,$ftppassword,$ftpwwwroot,$utf8,$publish_fs = 1, $publish_contentmap = 1, $contentmap_handle = '',$disable_publish=0, $editorversion = 0) {
 global $W_EDIT, $ERROR, $ERROR_ATTR, $DIC, $TIME, $USER_ID, $T_DOMAIN, $FEATURE, $T_NODE;

 if (!$name) {
 $ERROR = $DIC[855];
 return false;
 }

 if ($utf8) $utf8 = 1;
 else $utf8 = 0;

 
 $anode = sqlslashes($name);
 $sql = "SELECT id FROM folder WHERE mother = 0 AND name = '$anode' AND id != ".sqlf_tl_num($folder_id);
 $rs = query($sql,1);
 if ($rs["num"] > 0) {
 $ERROR = $DIC[856];
 return false;
 }

 
 $sql = "SELECT id FROM node WHERE host = '".sqlslashes($host)."' and pub_dir = '".sqlslashes($pub_dir)."' and folder_id != '".sqlf_escaped($folder_id)."'";
 $rs = query( $sql, 1);
 if ($rs['num'] > 0) {
 $ERROR = i18n( "Another node already has the same host and directory settings." );
 $ERROR_ATTR = 'host';
 return false;
 }

 $sql = "SELECT id FROM node WHERE folder_id = ".sqlf_tl_num($folder_id);
 $rs = query($sql);
 $node_id = $rs["arr"][0]["id"];
 $node = get_nodeinfo($node_id);
 

 
 $modified = getDiff(Array("pub_dir" => $pub_dir, "host" => $host, "publish_fs" => $publish_fs, "publish_contentmap" => $publish_contentmap), $node, TRUE);
 
 if($node["publish_fs"]!=$publish_fs) {
 $modified[] = "publish_fs";
 }
 if($node["publish_contentmap"]!=$publish_contentmap) {
 $modified[] = "publish_contentmap";
 }
 if($node["utf8"]!=$utf8) {
 $modified[] = "utf8";
 }

 
 $name = sqlslashes($name);
 $description = sqlslashes($description);
 $pub_dir = sqlslashes($pub_dir);
 $host = sqlslashes($host);
 if (!$ftpsync) $ftpsync = 0;
 if (!$publish_fs) $publish_fs = 0;
 if (!$publish_contentmap) $publish_contentmap = 0;
 $ftphost = sqlslashes($ftphost);
 $ftplogin = sqlslashes($ftplogin);
 $ftppassword = sqlslashes($ftppassword);
 $ftpwwwroot = sqlslashes($ftpwwwroot);
 if ($ftpwwwroot[strlen($ftpwwwroot)-1] == "/") $ftpwwwroot = substr($ftpwwwroot,0,strlen($ftpwwwroot)-1);
 if(!$ftpwwwroot) $ftpwwwroot = ".";
 $contentmap_handle = sqlslashes($contentmap_handle);
 $disable_publish = intval($disable_publish);
 $editorversion = intval($editorversion);
 
 
 
 $pub_dir = ereg_replace("\/*$","",$pub_dir);
 if (strlen($pub_dir) > 0 && $pub_dir[0] != "/") $pub_dir = "/".$pub_dir;

 
 if ($FEATURE["contentmap_handles"] && $contentmap_handle != '') {
 $sqlmaphandle = ", contentmap_handle = \"".sqlf_escaped($contentmap_handle)."\"";
 } else {
 $sqlmaphandle = "";
 }
 
 $sql = "UPDATE folder SET name='".sqlf_escaped($name)."', description='".sqlf_escaped($description)."', editor=".sqlf_tl_num($USER_ID).", edate=".sqlf_tl_num($TIME).", mother=0 WHERE id = ".sqlf_tl_num($folder_id);
 query($sql);
 
 $sql = "UPDATE node SET 
host = '".sqlf_escaped($host)."', pub_dir='".sqlf_escaped($pub_dir)."', editor=".sqlf_tl_num($USER_ID).", edate=".sqlf_tl_num($TIME).", editorversion=".sqlf_tl_num($editorversion).",
ftpsync = ".sqlf_tl_num($ftpsync).", ftphost = '".sqlf_escaped($ftphost)."', ftplogin = '".sqlf_escaped($ftplogin)."', ftppassword = '".sqlf_escaped($ftppassword)."', ftpwwwroot = '".sqlf_escaped($ftpwwwroot)."', publish_fs = ".sqlf_tl_num($publish_fs).", publish_contentmap = ".sqlf_tl_num($publish_contentmap).", utf8 = ".sqlf_tl_num($utf8)." $sqlmaphandle, disable_publish = ".sqlf_tl_num($disable_publish)."
 WHERE folder_id = ".sqlf_tl_num($folder_id);
 query($sql);
 
 logcmd($W_EDIT,$T_DOMAIN,$folder_id,0,"cmd_node_update publish_fs($publish_fs) publish_contentmap($publish_contentmap) disable_publish($disable_publish) host($host) pub_dir($pub_dir)");
 
 logcmd($W_EDIT, T_FOLDER, $folder_id, 0, "cmd_folder_update");

 if ($modified !== FALSE) { 
 triggerEvent(T_NODE, $node["id"], EVENT_UPDATE, new EventObject(NULL, $modified));
 
 if ($FEATURE["javaparser"]) {
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($T_NODE, $node_id);
 }
 }
 

 return $node_id;
 
}






function cmd_node_del($folder_id) { 
 global $ERROR, $JAVAPARSER_RETURN, $FEATURE;
 if ($FEATURE["multichannelling"]) {
 
 while (list($k) = each($folder_id)) {
 $r = query("SELECT COUNT(*) c FROM folder WHERE master_id = " . sql_num($k));
 if ($r['arr'][0]['c'] > 0) {
 $ERROR = i18n('delete_error_channel_found');
 return true;
 }
 }
 reset($folder_id);
 }
 
 $javaParser =& CodeParser::getJavaParser();
 $del_ids = array();
 
 if (is_array($folder_id)) {
 while (list($key,$val) = each($folder_id)) {
 $sql = "SELECT node_id FROM folder WHERE id = ".sqlf_tl_num($key);
 $rs = query($sql);
 $del_ids[] = $rs["arr"][0]["node_id"];
 }
 } else {
 $sql = "SELECT node_id FROM folder WHERE id = ".sqlf_tl_num($folder_id);
 $rs = query($sql);
 $del_ids[] = $rs["arr"][0]["node_id"];
 }

 
 $ERROR = $javaParser->deleteObject(T_NODE, $del_ids);

 if (!empty($ERROR)) {
 if (isset($JAVAPARSER_RETURN["params"]["halt"])) {
 halt(7, $ERROR);
 } else {
 return true;
 }
 } else {
 return false;
 }

 return false;
}












function cmd_node_copy_enqueue($node_list, $num = 1, $copy_pages = false, $copy_templates = false, $copy_files = false, $copy_workflows = false) {
 global $FILEPATH, $USER_ID, $FEATURE;
 if ($FEATURE["nodecopy"] && is_array($node_list)) {
 
 if (!is_dir($FILEPATH."/content/nodecopy/")) {
 mkdir($FILEPATH."/content/nodecopy/");
 }

 $lockhandle = fopen($FILEPATH."/content/nodecopy/nodecopy.lock", "w");
 flock($lockhandle, LOCK_EX);
 $handle = fopen($FILEPATH."/content/nodecopy/nodecopy.jobs", "a+");

 foreach ($node_list as $node) {
 fwrite($handle, "$node\t$num\t$USER_ID\t".($copy_pages ? "yes" : "no")."\t".($copy_templates ? "yes" : "no")."\t".($copy_files ? "yes" : "no")."\t".($copy_workflows ? "yes" : "no")."\n");
 }

 fclose($handle);
 fclose($lockhandle);
 }
}




function cmd_node_copy(&$lines) {

 global $FILEPATH, $NODECOPY_CMD, $NODECOPY_MEMORY, $FEATURE, $SETTINGS;

 $retval = 0;
 if ($FEATURE["nodecopy"]) {
 
 

 $mem = ($NODECOPY_MEMORY) ? "-Xmx$NODECOPY_MEMORY" : "";
 $nodecopy_base_cmd = str_replace("NODECOPY_MEMORY", $mem, $NODECOPY_CMD);
 $nodecopy_cmd = $nodecopy_base_cmd . " -u ".$SETTINGS["login"];

 if ($SETTINGS["pw"]) {
 
 $nodecopy_cmd .= " -p ".$SETTINGS["pw"];
 }
 $nodecopy_cmd .= " --url " . escapeshellcmd(mydb_get_jdbc_url());

 
 if (!is_dir($FILEPATH."/content/nodecopy/")) {
 mkdir($FILEPATH."/content/nodecopy/");
 }

 
 $lockhandle = fopen($FILEPATH."/content/nodecopy/nodecopy.lock", "w");
 flock($lockhandle, LOCK_EX);
 
 $nodes = file($FILEPATH."/content/nodecopy/nodecopy.jobs");
 
 unlink($FILEPATH."/content/nodecopy/nodecopy.jobs");
 
 fclose($lockhandle);
 foreach ($nodes as $node) {
 $parts = explode("\t", trim($node));
 
 for ($i = 0; $i < $parts[1] && $retval == 0; ++$i) {
 exec($nodecopy_cmd." -Dnode=".$parts[0]." -Dcopypage=".$parts[3]." -Dcopyperm=yes -Dcopytemplate=".$parts[4]." -Dcopyfile=".$parts[5]." -Dcopyworkflow=".$parts[6]. " -DdbFileContentInDB=" . ($FEATURE['contentfile_data_to_db']?'true':'false') . " -Dfilepath=\"$FILEPATH/content/dbfiles\"", $lines, $retval);
 }
 if ($retval == 0) {
 $sourcenode = get_nodeinfo($parts[0]);
 $nodefolder = get_folderinfo($sourcenode["folder_id"]);
 $targetnodes = Array();
 
 foreach ($lines as $line) {
 if( is_numeric(trim($line)) ) {
 $target = get_nodeinfo($line);
 $targetfolder = get_folderinfo($target["folder_id"]);
 $targetnodes[] = $targetfolder["name"];
 }
 }
 
 msg(i18n("nodecopy_done", 0, $nodefolder["name"], $parts[1], implode("\n", $targetnodes)), $parts[2], 1);
 } else {
 
 break;
 }
 }
 }

 return $retval;
}
?>
