<?php
$mainGUI = &GUIFactory::setMainGUI( "main" );

node_class("htmlform3");
node_class("listcomponent");
node_class("textcomponent");
node_class("selectcomponent");
node_class("labelcomponent");


$ASSCORE = "";

if ($cmd == "new") {
 unset($CR_ID); 
}

if( is_numeric($cr_id) ) {
 $CR_ID = $cr_id;
}

node_include("load_menu");
mysession_var_reg("CR_ID");

load_menu(15214,T_CONTENTREPOSITORY,$CR_ID);

$allowedit = false;

if ($CR_ID) {
 $contentrepository = &NodeFactory::getStaticInstanceOf(T_CONTENTREPOSITORY, $CR_ID);
 $cmd = "edit";
 $allowedit = perm($USER_ID, T_CONTENTREPOSITORY, $CR_ID, 2);
} else {
 $contentrepository = &NodeFactory::getStaticInstanceOf(T_CONTENTREPOSITORY);
 $cmd = "create";
 $allowedit = perm($USER_ID, T_CONTENTREPOSITORIES, 0, 8);
}

if ($allowedit) {
 $NODERELATED[$DO] = $NODERELATED_CR_STRUCT;
 if (perm($USER_ID, $T_CONTENT, 0, 0) && perm($USER_ID, $T_CONTENT, 0, 8)) {
 $NODERELATED[$DO] = $NODERELATED_CR_NODES;
 }
}


$crForm = new HtmlForm3("cr");

if ($crForm->isNew()) {
 $crForm->setHeader($contentrepository->getFieldValue("name"));
 
 $main = new ListComponent();
 
 $main->setComponent('name', $comp = new TextComponent(i18n("Name"), true, $contentrepository->getFieldValue("name"), REG_TEXT_SHORT));
 if (!$allowedit) {
 $comp->setEditable(false);
 }

 
 $types = array();
 while (list ($key, $val) = each ($CONTENTREPOSITORY_DATABASES)) {
 if ($CONTENTREPOSITORY_DRIVERCLASS[$key]) {
 $types[$key] = $val;
 }
 }

 $main->setComponent('dbtype', $comp = new SelectComponent(i18n("dbtype"), $types, $contentrepository->getFieldValue("dbtype")));
 if (!$allowedit) {
 $comp->setEditable(false);
 }

 $main->setComponent('url', $comp = new TextComponent(i18n("url"), true, $contentrepository->getFieldValue("url"), REG_NOTEMPTY));
 if (!$allowedit) {
 $comp->setEditable(false);
 }

 $main->setComponent('username', $comp = new TextComponent(i18n("username"), true, $contentrepository->getFieldValue("username"), REG_TEXT_SHORT));
 if (!$allowedit) {
 $comp->setEditable(false);
 }

 
 if ($FEATURE['instant_cr_publishing']) {
 $main->setComponent('instant_publishing', $comp = new CheckBoxComponent(i18n('instant publishing'), $contentrepository->getFieldValue('instant_publishing')));
 if (!$allowedit) {
 $comp->setEditable(false);
 }
 }
 $main->setComponent('language_information', $comp = new CheckBoxComponent(i18n('add language information'), $contentrepository->getFieldValue('language_information')));
 if (!$allowedit) {
 $comp->setEditable(false);
 }

 $main->setComponent('permission_information', $comp = new CheckBoxComponent(i18n('add permission information'), $contentrepository->getFieldValue('permission_information')));
 if (!$allowedit) {
 $comp->setEditable(false);
 }

 $main->setComponent('usepassword', $comp = new CheckBoxComponent(i18n("use password"), $cmd == "new" || $contentrepository->getFieldValue("password")));
 $comp->setOnChangeAction(new FormAction());
 if (!$allowedit) {
 $comp->setEditable(false);
 }

 $main->setComponent('password', $comp = new PasswordComponent(i18n("password"), true, ""));
 if (!$allowedit) {
 $comp->setEditable(false);
 }
 
 $main->setComponent('password2', $comp = new PasswordComponent(i18n("password repeat"), true, ""));
 if (!$allowedit) {
 $comp->setEditable(false);
 }























 $crForm->addComponent('main', $main);

 if ($allowedit) {
 $crForm->addButton('ok', new Button(i18n("OK")), new SimpleFormAction("save"), true);
 }
 $crForm->addButton('cancel', new Button(i18n("cancel"), false ), new RedoFormAction(15210), false);
 







}


$passwordcomp = &$crForm->resolveComponent("main.password");
$password2comp = &$crForm->resolveComponent("main.password2");
$usepasscomp = &$crForm->resolveComponent("main.usepassword");
if ($usepasscomp->isChecked()) {
 
 $passwordcomp->setVisible(true);
 $password2comp->setVisible(true);
} else {
 
 $passwordcomp->setVisible(false);
 $password2comp->setVisible(false);
}




function save(&$form) {
 global $CR_ID, $REDO, $FEATURE;
 $usepasscomp = &$form->resolveComponent("main.usepassword");

 if ($usepasscomp->isChecked()) {
 $passwordcomp = &$form->resolveComponent("main.password");
 $password2comp = &$form->resolveComponent("main.password2");

 
 $pwd = $passwordcomp->getText();
 $pwd2 = $password2comp->getText();

 if( $pwd && ($pwd != $pwd2)) {
 $passwordcomp->addError(new NodeException(i18n("repeat password error")));
 return;
 }
 } else {
 $unset_passwd = true;
 }

 $namecomp = &$form->resolveComponent("main.name");
 $dbtypecomp = &$form->resolveComponent("main.dbtype");
 $urlcomp = &$form->resolveComponent("main.url");
 $usernamecomp = &$form->resolveComponent("main.username");


 $contentrepository = new ContentRepository($CR_ID);
 $contentrepository->setFieldValue("name", $namecomp->getText());
 $contentrepository->setFieldValue("dbtype", $dbtypecomp->getSingleSelection());
 $contentrepository->setFieldValue("url", $urlcomp->getText());
 $contentrepository->setFieldValue("username", $usernamecomp->getText());

 if ($pwd) {
 $contentrepository->setFieldValue("password", $pwd);
 } else if ($unset_passwd) {
 $contentrepository->setFieldValue("password", "");
 }

 if ($FEATURE['instant_cr_publishing']) {
 $instant_publishing = &$form->resolveComponent('main.instant_publishing');
 $contentrepository->setFieldValue('instant_publishing', $instant_publishing->isChecked() ? 1 : 0);
 }

 $language_information = &$form->resolveComponent('main.language_information');
 $contentrepository->setFieldValue('language_information', $language_information->isChecked() ? 1 : 0);

 $permission_information = &$form->resolveComponent('main.permission_information');
 $contentrepository->setFieldValue('permission_information', $permission_information->isChecked() ? 1 : 0);

 
























 $contentrepository->save();
 $CR_ID = $contentrepository->getID();

 


 $REDO = 15210;
}

?>
