<?
GUIFactory::setMainGUI( "main" );


if ($USER_ID != 1 && !perm($USER_ID, T_CONTENT, null, 0)) {
 halt(7, "no perms to view nodes");
}
if ($USER_ID != 1 && $FOLDER_ID && !perm($USER_ID, T_DOMAIN, $FOLDER_ID, 0) && !perm($USER_ID, T_DOMAIN_CHANNEL, $FOLDER_ID, 0)) {
 halt(7, "no perms to view properties of root folder $FOLDER_ID");
}


if ($USER_ID == 1 || perm($USER_ID, T_DOMAIN, $FOLDER_ID, 9) || perm($USER_ID, T_DOMAIN_CHANNEL, $FOLDER_ID, 9) || !$FOLDER_ID) {
 $update_perms = true;
}

if ($FOLDER_ID && $cmd != "new") {
 load_menu(11001,$T_FOLDER,$FOLDER_ID,"",1,14002);
}


$f = $HI["text"];
$f["label"] = $DIC[368];
$f["var"] = "name";
$f["help"] = $DIC[368];
$f["regid"] = 17;
$hi[] = $f;

$f = $HI["text"];
$f["label"] = i18n("cn_hostname");
$f["var"] = "host";
$f["regid"] = 25;
$hi[] = $f;

$f = $HI["text"];
$f["label"] = $DIC[369];
$f["var"] = "pub_dir";
$f["help"] = $DIC[369];
$f["regid"] = 9;
$hi[] = $f;

if ($FEATURE['multichannelling']) {
 if ($cmd === 'new') {
 
 $folders = array();
 $rs = query("SELECT id, name FROM folder WHERE mother = 0 ORDER BY LOWER(name) ASC");
 while (list($k,$f) = each($rs["arr"])) {
 if (perm($USER_ID, T_FOLDER, $f["id"], 0)) {
 $folders[$f["id"]] = $f["name"];
 }
 }
 
 $f = $HI["sel"];
 $f["var"] = "master_id";
 $f["label"] = i18n('derives_from');
 $f["help"] = i18n('help_select_channel_master');
 $f["list"] = $folders;
 $f["optional"] = true;
 } else {
 
 
 
 $f = $HI["hidden"];
 $f["var"] = "master_id";
 $hi[] = $f;
 
 
 $f = $HI["text"];
 $f["var"] = "master_name";
 $f["label"] = i18n('derives_from');
 $f["help"] = i18n("help_select_channel_master");
 $f["optional"] = true;
 $f["disabled"] = true;
 }
 $hi[] = $f;
}

if ($FEATURE["UTF8"]) {
 $f = $HI["checkbox"];
 $f["label"] = i18n("UTF8");
 $f["var"] = "utf8";
 $hi[] = $f;
}

if ($FEATURE["aloha"]) {
 $f = $HI["checkbox"];
 $f["label"] = i18n("Aloha");
 $f["var"] = "editorversion";
 $f["help"] = i18n("Use the next generation Live Editor. Requires UTF-8.");
 $hi[] = $f;
}




 
$f = $HI["checkbox"];
$f["label"] = i18n('Publizierung deaktivieren');
$f["var"] = "disable_publish";
$f["help"] = i18n("disable_publish_help");
$hi[] = $f;

$f = $HI["checkbox"];
$f["label"] = i18n("publish into the filesystem");
$f["var"] = "publish_fs";
$f["help"] = i18n("publish_fs_help");
$hi[] = $f;

if ($FEATURE["contentmap"]) {
 $f = $HI["checkbox"];
 $f["label"] = i18n("publish into the contentmap");
 $f["var"] = "publish_contentmap";
 $f["help"] = i18n("publish_contentmap_help");
 $hi[] = $f;
 
 $f = $HI["text"];
 $f["var"] = "crname";
 $f["label"] = "ContentRepository"; 
 $f["optional"] = true;
 $f["disabled"] = true;
 $f["help"] = i18n("node_crname_help");
 $hi[] = $f;
 
 $crFieldId = (count($hi) - 1);
}

if ($FEATURE["node_ftp"]) {


$f = $HI["checkbox"];
$f["label"] = i18n("cn_ftp_sync");
$f["var"] = "ftpsync";
$hi[] = $f;

$f = $HI["text"];
$f["label"] = i18n("cn_ftp_hostname");
$f["var"] = "ftphost";
$f["optional"] = true;
$hi[] = $f;

$f = $HI["text"];
$f["label"] = i18n("cn_ftp_login");
$f["var"] = "ftplogin";
$f["optional"] = true;
$hi[] = $f;

$f = $HI["password"];
$f["label"] = i18n("cn_ftp_password");
$f["var"] = "ftppassword";
$f["optional"] = true;
$f["regid"] = 0;
$hi[] = $f;

$f = $HI["text"];
$f["label"] = i18n("cn_ftp_webroot");
$f["var"] = "ftpwwwroot";
$f["optional"] = true;
$hi[] = $f;

} 


$f = $HI["ta"];
$f["label"] = $DIC[305];
$f["var"] = "description";
$f["help"] = $DIC[305];
$f["regid"] = 9;
$f["optional"] = true;
$hi[] = $f;

$f = $HI["hidden"];
$f["var"] = "redo";
$hi[] = $f;

$f = $HI["hidden"];
$f["var"] = "cmd";
$hi[] = $f;


$f = $HI["hidden"];
$f["var"] = "checksum";
$hi[] = $f;


if ($update_perms) {
 $hi[] = $HI["ok"];
}

$hi[] = $HI["cancel"];


$f = new htmlform($hi);

if (!$redo) $redo = 11012;

if ($faction == "cancel") {

 unset($action);
 unset($hi);
 $REDO = $redo;
} else {

 if ($f_editorversion == ALOHA && !$f_utf8) {
 $ERROR = i18n("Aloha requires UTF-8");
 $f->check["editorversion"] = $ERROR;
 } 


 if (!$f->err() && $faction == "ok") {
 
 
 switch ($cmd):
 case "new":
 if ($USER_ID != 1 && !perm($USER_ID, T_CONTENT, null, 8)) {
 halt(7, "no perms to create a new node");
 }

 if ( ! list($name, $description, $host, $pub_dir)
 = validate_node_props($name, $description, $host, $pub_dir, $f) )
 {
 return;
 }

 $node_id = cmd_node_create($name,$host,$pub_dir,$description,$ftpsync,$ftphost,$ftplogin,$ftppassword,$ftpwwwroot,$utf8,$publish_fs,$publish_contentmap, $contentmap_handle, $disable_publish, $editorversion, $master_id);
 $NODE_ID = $node_id;
 
 $sql = "SELECT count(*) AS c FROM construct WHERE id = 1";
 $rs = query($sql);
 if ($rs["arr"][0]["c"] == 1) 
 cmd_construct_node(1,array($node_id=>1));
 break;
 case "update":
 


 
 foreach ($hi as $formElement) {
 if (strcmp($formElement["type"],"checkbox") == 0 && !$$formElement["var"]) {
 $$formElement["var"] = 0;
 } 
 }
 $checksum_new = md5($name.$host.$pub_dir.$description.$ftpsync.$ftphost.$ftplogin.
 $ftppassword.$ftpwwwroot.$utf8.$publish_fs.$publish_contentmap.$contentmap_handle.$disable_publish.$editorversion);
 if (strcmp($checksum,$checksum_new) != 0) {
 
 if ($update_perms) {

 if ( ! list($name, $description, $host, $pub_dir)
 = validate_node_props($name, $description, $host, $pub_dir, $f) )
 {
 return;
 }

 $node_id = cmd_node_update($FOLDER_ID,$name,$host,$pub_dir,$description,$ftpsync,$ftphost,$ftplogin,
 $ftppassword,$ftpwwwroot,$utf8,$publish_fs,$publish_contentmap, $contentmap_handle,$disable_publish, $editorversion);
 }
 } else {
 
 $sql = "SELECT id FROM node WHERE folder_id = ".sqlf_tl_num($FOLDER_ID);
 $rs = query($sql);
 $node_id = $rs["arr"][0]["id"];
 }
 break;
 endswitch;
 

 
 if (!$node_id) {
 $errattr = 'name';
 if( $ERROR_ATTR )
 $errattr = $ERROR_ATTR;
 $f->check[$errattr] = $ERROR;
 } else {
 $JS = "
if (top.tree) {
  top.tree.location='$STAG&do=300';
}
";
 unset($action);
 unset($hi);
 $REDO = $redo;
 }
 }

 
 switch ($cmd):
 case "new":
 
 if (!$f->err()) $f->clear();
 
 $cmd = "new";
 $name = $DIC[854];
 $pub_dir = "/Content.Node/";
 $utf8 = 1;
 $editorversion = ALOHA;
 break;
 case "update":
 $sql = "SELECT f.name, f.description, n.host, n.pub_dir, n.ftpsync, n.ftphost, n.ftplogin, n.ftppassword, n.ftpwwwroot, n.utf8,
                    n.publish_fs, n.publish_contentmap, n.contentmap_handle, n.disable_publish, c.name crname, c.id crid,
                    n.editorversion, bpm.id as master_id, bpm.name as master_name
            FROM node n
            INNER JOIN folder f ON f.node_id = n.id AND n.folder_id = f.id
            LEFT JOIN folder bpm ON f.master_id = bpm.id
            LEFT JOIN contentrepository c ON n.contentrepository_id = c.id 
            WHERE f.id = ".sqlf_tl_num($FOLDER_ID)." AND n.folder_id = ".sqlf_tl_num($FOLDER_ID);
 $rs = query($sql);
 $name= $rs["arr"][0]["name"];
 $host = $rs["arr"][0]["host"];
 $pub_dir = $rs["arr"][0]["pub_dir"];
 $description = $rs["arr"][0]["description"];
 $ftpsync = $rs["arr"][0]["ftpsync"];
 $ftphost = $rs["arr"][0]["ftphost"];
 $ftplogin = $rs["arr"][0]["ftplogin"];
 $ftppassword = $rs["arr"][0]["ftppassword"];
 $ftpwwwroot = $rs["arr"][0]["ftpwwwroot"];
 $utf8 = $rs["arr"][0]["utf8"];
 $publish_fs = $rs["arr"][0]["publish_fs"];
 $publish_contentmap = $rs["arr"][0]["publish_contentmap"];
 $contentmap_handle = $rs["arr"][0]["contentmap_handle"];
 $disable_publish = $rs["arr"][0]["disable_publish"];
 $crname = $rs["arr"][0]["crname"];
 $editorversion= $rs["arr"][0]["editorversion"];
 $crid = $rs["arr"][0]["crid"];
 $master_id = $rs["arr"][0]["master_id"];
 $master_name = $rs["arr"][0]["master_name"];
 




 $checksum = md5($name.$host.$pub_dir.$description.$ftpsync.$ftphost.$ftplogin.$ftppassword.$ftpwwwroot.$utf8.$publish_fs.$publish_contentmap.$contentmap_handle.$disable_publish.$editorversion);
 $NODE_ID = $rs["arr"][0]["id"];
 break;
 default:
 halt(7,"No cmd for node update or insert");
 break;
 endswitch;

}

if (!$REDO) {
 if ($publish_contentmap && !$publish_fs) {
 $linkway = "portal";
 } else {
 $linkway = $LINKWAY;
 }

 if ($linkway == "portal" || $linkway == "auto" || $linkway == "host") {
 $ASSCORE = i18n("node_linkway_$linkway")."<br/>".i18n("node_linkway_description");
 }
}










function validate_node_props($name, $description, $host, $pub_dir, $html_form) {
 node_include('validation');
 return validate_properties_htmlform(
 array('nodeName' => $name,
 'nodeDescription' => $description,
 'hostName' => $host,
 'fsPath' => $pub_dir),
 new InputValidationRequest(),
 $html_form,
 array('nodeName' => 'name',
 'nodeDescription' => 'description',
 'hostName' => 'host',
 'fsPath' => 'pub_dir'));
}


