<?




function push2master(&$form) {
 global $CN_LOCAL_SERVER, $SESSION_TOKEN, $JS, $REDO, $CHANNELSYNC_SELTYPE;

 $masterComp = &$form->resolveComponent('main.overview.master');
 $recursiveComp = &$form->resolveComponent('main.overview.recursive');
 $objTypeComp = &$form->resolveComponent('main.overview.obj_type');
 $objIdComp = &$form->resolveComponent('main.overview.obj_id');
 $channelIdComp = &$form->resolveComponent('main.overview.channel_id');
 $backDoComp = &$form->resolveComponent('main.overview.backdo');

 $objType = $objTypeComp->getValue();
 switch($objType) {
 case T_PAGE:
 $restPart = "page";
 break;
 case T_TEMPLATE:
 $restPart = "template";
 break;
 case T_FOLDER:
 $restPart = "folder";
 break;
 case T_IMAGE:
 $restPart = "image";
 break;
 case CT_FILE:
 $restPart = "file";
 break;
 default:
 halt(7,'Could not get objType');
 }
 $objId = explode(",", $objIdComp->getValue());
 $recursive = $recursiveComp->isChecked() ? "true" : "false";
 $channelId = $channelIdComp->getValue();
 $masterId = $masterComp->getSingleSelection();

 $request = array("masterId" => $masterId, "channelId" => $channelId, "recursive" => $recursive, "ids" => $objId);
 if ($objType == T_FOLDER) {
 
 $request["types"] = array_keys($CHANNELSYNC_SELTYPE);
 }

 
 $fc = new fetchCurl();
 $url = "$CN_LOCAL_SERVER/CNPortletapp/rest/$restPart/push2master?sid=$SESSION_TOKEN";
 $fc->setUrl($url);
 $fc->setSubmitType("POST");
 $fc->setPostData(json_encode($request));
 $fc->setHeader("Content-Type", "application/json");
 $json = $fc->doRequest();

 
 if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp.');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
 }

 $response = json_decode($json, true);
 while (list($key, $m) = each($response["messages"])) {
 $msg = str_replace("\n", "\\n", str_replace('"', '\"', $m["message"]));
 $JS .= ' alert( "'.$msg.'" ); ';
 }

 $REDO = $backDoComp->getValue();
}





function unlocalize(&$form) {
 global $CN_LOCAL_SERVER, $SESSION_TOKEN, $JS, $REDO, $CHANNELSYNC_SELTYPE;

 $recursiveComp = &$form->resolveComponent('main.overview.recursive');
 $objTypeComp = &$form->resolveComponent('main.overview.obj_type');
 $objIdComp = &$form->resolveComponent('main.overview.obj_id');
 $channelIdComp = &$form->resolveComponent('main.overview.channel_id');
 $backDoComp = &$form->resolveComponent('main.overview.backdo');

 $objType = $objTypeComp->getValue();
 switch($objType) {
 case T_PAGE:
 $restPart = "page";
 break;
 case T_TEMPLATE:
 $restPart = "template";
 break;
 case T_FOLDER:
 $restPart = "folder";
 break;
 case T_IMAGE:
 $restPart = "image";
 break;
 case CT_FILE:
 $restPart = "file";
 break;
 default:
 halt(7,'Could not get objType');
 }
 $objId = explode(",", $objIdComp->getValue());
 $recursive = $recursiveComp->isChecked() ? "true" : "false";
 $channelId = $channelIdComp->getValue();

 $request = array("channelId" => $channelId, "recursive" => $recursive, "ids" => $objId);
 if ($objType == T_FOLDER) {
 
 $request["types"] = array_keys($CHANNELSYNC_SELTYPE);
 }

 
 $fc = new fetchCurl();
 $url = "$CN_LOCAL_SERVER/CNPortletapp/rest/$restPart/unlocalize?sid=$SESSION_TOKEN";
 $fc->setUrl($url);
 $fc->setSubmitType("POST");
 $fc->setPostData(json_encode($request));
 $fc->setHeader("Content-Type", "application/json");
 $json = $fc->doRequest();

 
 if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp.');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
 }

 $response = json_decode($json, true);
 while (list($key, $m) = each($response["messages"])) {
 $msg = str_replace("\n", "\\n", str_replace('"', '\"', $m["message"]));
 $JS .= ' alert( "'.$msg.'" ); ';
 }

 $REDO = $backDoComp->getValue();}
?>