<?

class FileCheckout {
 var $fields = array(
 'id',
 'name',
 'md5',
 'edate'
 );
 var $folder_id;
 var $session_id;
 var $user_id;
 var $result = array();
 var $file_path;
 var $dav_path;
 var $indexed_files = array();
 var $old_index;
 var $newIndex;
 var $errors = array();
 var $actions = array(
 'new' => array(),
 'upd' => array(),
 'del' => array()
 );
 var $maxFilesize;

 function addError($action, $short, $detail) {
 $this->errors[] = array(
 'action' => $action,
 'short' => $short,
 'detail' => $detail
 );
 }

 function getErrors() {
 return $this->errors;
 }

 function getErrorCount() {
 return count($this->errors);
 }

 function clear() {
 $this->actions = array(
 'new' => array(),
 'upd' => array(),
 'del' => array()
 );
 $this->errors = Array();
 }

 function getMaxFilesize() {
 return $this->maxFilesize;
 }
 
 function getActions() {
 return $this->actions;
 }
 
 function FileCheckout($fid, $sid, $uid, $filepath, $davpath) {
 $this->folder_id = $fid;
 $this->session_id = $sid;
 $this->user_id = $uid;
 $this->file_path = $filepath . '/content/dbfiles';
 $this->dav_path = $davpath;
 $this->maxFilesize = min(gtxreturn_bytes(ini_get('post_max_size')), gtxreturn_bytes(ini_get('upload_max_filesize')));
 }
 
 function readFiles() {
 global $FEATURE;
 $this->result = query(sprintf("SELECT %s FROM contentfile WHERE folder_id = %s",
 join(', ', sqlf_field_array($this->fields)),
 sqlf_tl_num($this->folder_id)
 ));
 $this->cleanup();
 if (!file_exists($this->dav_path . '' . $this->session_id)) {
 mkdir($this->dav_path . '' . $this->session_id);
 chmod($this->dav_path . '' . $this->session_id, 0777);
 }
 if ($this->result['num'] > 0) {
 foreach ($this->result['arr'] as $entry) {
 if($FEATURE["contentfile_data_to_db"]) {
 $datars = query("SELECT binarycontent FROM contentfiledata WHERE contentfile_id=".sqlf_tl_num($entry["id"]));
 $fp = @fopen($this->dav_path.''.$this->session_id.'/'.$entry['name'], "w");
 fwrite($fp,$datars["arr"][0]["binarycontent"]);
 fclose($fp);
 chmod($this->dav_path.''.$this->session_id.'/'.$entry['name'], 0777);
 
 } else {
 
 copy(
 $this->file_path . '/' . $entry['id'] . '.bin', 
 $this->dav_path . '' . $this->session_id . '/' . $entry['name']
 );
 }
 $old_index[$entry["id"]]["name"] = $entry["name"];
 $old_index[$entry["id"]]["md5"] = $entry["md5"];
 $old_index[$entry["id"]]["edate"] = $entry["edate"];
 }
 }
 
 $this->old_index = $old_index;
 }

 function buildIndex() {
 $ret = array();
 $path = $this->dav_path . '' . $this->session_id;
 if (is_dir($path)) {
 $handle = opendir($path);
 while (($file = readdir($handle))) {
 if ($file != '.' && $file != '..' && !is_dir($path . '/' . $file)) {
 $ret[$file] = md5_file($path."/".$file);
 







 }
 }
 }
 return $ret;
 }

 









































 






 function fileData($id, $pathprefix, $newname, $fs) {
 $fp = fopen("$pathprefix/$newname", 'r');
 $data = fread($fp, $fs);
 fclose($fp);
 
 $type = exec("file -b -i \"$pathprefix/$newname\"");
 
 
 if (eregi (".*\.xls$", $newname) && $type == "application/msword")
 $type = "application/vnd.ms-excel";

 
 if (eregi (".*\.ppt$", $newname) && $type == "application/msword")
 $type = "application/vnd.ms-powerpoint";

 
 $ext = substr($newname, strrpos($newname, '.')+1);
 $newmimetype = $DAV_MIME_MAPPINGS[$ext];
 if( $newmimetype ) {
 $type = $newmimetype;
 }
 
 cmd_file_data($id, $data, $fs, $type);
 }
 
 





 function getContentFileInfo($name, $folderId) {
 $result = query("SELECT id, description FROM contentfile WHERE name='".sqlslashes($name)."' AND folder_id = ".sqlf_tl_num($this->folder_id));
 if ($result['num'] > 0) {
 return $result['arr'][0];
 } else {
 $this->addError(
 i18n('Update File {0}', 0, $name),
 'Didn\'t find the content of file '.$name.' in folder with id '.$this->folder_id.'.',
 'Didn\'t find the content of file '.$name.' in folder with id '.$this->folder_id.'.'
 );
 }
 
 return false;
 }
 
 function sync($doit = false) {
 
 global $DAV_MIME_MAPPINGS;

 $this->clear();
 
 $new_index = $this->buildIndex();
 $pathprefix = $this->dav_path . '' . $this->session_id;
 
 foreach($this->old_index as $oldid => $old) {
 $f = get_fileinfo($oldid);
 if (!$f["id"] || $f["edate"] > $old["edate"]) {
 $this->addError(
 i18n('Update File {0}', 0, $old["name"]),
 i18n('File {0} changed since checkout.', 0, $old["name"]),
 i18n('The File {0} changed since you started editing your Files. Please review changes.', 0, $old["name"])
 );
 }

 if (!$new_index[$old['name']]) {
 $deleted[$old['name']] = $oldid;
 }
 }
 
 
 
 
 $handled = array(); 
 
 
 foreach($new_index as $newname=>$md5) {
 $fs = filesize("$pathprefix/$newname");
 
 
 if ($fs > $this->maxFilesize) {
 $this->actions['skipped'][] = array('name' => $newname, 'size' => $fs);
 continue;
 }

 global $REG;
 if ( ! regex_match_utf8($REG[REG_FILENAME]["exp"], $newname)) {
 $this->actions['error'][] = array('name' => $newname, 'error' => $REG[REG_FILENAME]["desc"]);
 continue;
 }

 $filenameExistedInOld = false; 
 $contentExistedInOld = false; 
 $contentCount = 0;
 foreach ($this->old_index as $oldid => $entry) { 
 
 if ($entry['md5'] == $md5) {
 $contentCount++;
 $oldname = $entry['name'];
 }
 
 if ($entry['name'] == $newname) {
 $filenameExistedInOld = true;
 $oldMd5 = $entry['md5'];
 }
 }
 if ($contentCount == 1) {
 $contentExistedInOld = true;
 }
 
 $newfile = false;
 
 
 if ($filenameExistedInOld) {
 
 if ($md5 != $oldMd5) {
 $info = $this->getContentFileInfo($newname, $this->folder_id);
 $id = $info['id'];
 
 
 if (array_search($id, $handled) === false) {
 $this->actions['upd'][] = $newname;
 if ($doit) {
 if ($id) {
 $this->fileData($id, $pathprefix, $newname, $fs);
 }
 }
 } else {
 
 $newfile = true;
 }
 } else {
 
 $info = $this->getContentFileInfo($newname, $this->folder_id);
 $id = $info['id'];
 }
 } else {
 
 if ($contentExistedInOld) {
 $info = $this->getContentFileInfo($oldname, $this->folder_id);
 $id = $info['id'];
 
 
 if (array_search($id, $handled) === false) {
 $this->actions['upd'][] = $newname;
 unset($deleted[$oldname]); 
 if ($doit) {
 if ($id) {
 cmd_file_update($id,$this->folder_id,$newname, $info['description']);
 }
 }
 } else {
 
 $newfile = true;
 }
 } else {
 
 $newfile = true;
 }
 }
 
 if ($newfile) {
 $this->actions['new'][] = $newname;
 if ($doit) {
 $id = cmd_file_create($newname,$this->folder_id, '');
 $this->fileData($id, $pathprefix, $newname, $fs);
 }
 }
 
 $handled[] = $id;
 }
 
 
 if (isset($deleted)) {
 foreach ($deleted as $oldname => $oldid) {
 if ($doit) {
 cmd_file_del($oldid);
 }
 $this->actions['del'][] = $oldname;
 }
 }
 }




























































































































































































 function cleanup() {
 $path = $this->dav_path . '' . $this->session_id;
 $this->clean($path);
 












 }

 function clean($path) {
 if (file_exists($path)) {
 $handle = opendir($path);
 while (($file = readdir($handle))) {
 $abs_name = $path . '/' . $file;
 if (is_dir($abs_name) AND $file != '.' AND $file != '..') {
 $this->clean($abs_name);
 } elseif(is_file($abs_name) AND $file != '.' AND $file != '..') {
 unlink($abs_name);
 } else {
 
 }
 }
 rmdir($path);
 }
 }
}

?>
