<?






function part_update($pid,$type_id,$cid,$editable,$type,$tid = 0,$required=true, $returnFalseIfNotChanged=false, $changePageStatus=true) {

 global $ERROR, $TABLE_TAG, $O_TYPE, $O_ID, $TAG_PREFIX, $TAG_FORMAT, $FEATURE;

 reset_global_validation_result();

 $val_ref = 0;
 $val_text = "";
 $info = 0;
 $skipupdate = false;

 
 if ($editable) $static = 0;
 else $static = 1;
 
 if (!$pid) halt(7,"part_update: invalid pid($pid). tid($tid), type_id($type_id), cid($cid)");

 if ($type == "construct" && $tid > 1) halt(7,"part_update: construct and tag_id given: type($type) tid($tid)");

 if ($type == "construct") $sqlpart = "globaltag";
 else if ($type == "global") $sqlpart = "globaltag";
 else if ($type == "template") $sqlpart = "templatetag";
 else if ($type == "content") $sqlpart = "contenttag";
 else if ($type == "obj") $sqlpart = "objtag";
 else halt(7,"part_update: no valid type: type($type)");

 if ($sqlpart) $sqlpart2 = "AND ".$sqlpart."_id = ".sqlf_tl_num($tid);
 if ($editable && !$tid) $sqlpart2 = "AND globaltag_id = 0 AND templatetag_id = 0 AND contenttag_id = 0 AND objtag_id = 0";


 
 $sql = "SELECT count(*) AS c FROM value WHERE part_id = ".sqlf_tl_num($pid)." $sqlpart2";
 $rs = query($sql);
 if ($rs["arr"][0]["c"] == 0) {
 cmd_insert_value( "", false, false, $type, $tid, $pid, $static, false, $changePageStatus );
 }

 
 if ($type_id == 1 || $type_id == 2 || $type_id == 3 || $type_id == 9 || $type_id == 10 || $type_id == 21 || $type_id == 26 || $type_id == 27 || $type_id == 36 || $type_id == 37) {
 $tmp = "p".$pid."_a";
 global $$tmp;
 if ($type_id == 27 || ($type == 10 && $FEATURE["dhtml_texttags"])) $val_text = ereg_replace("\&lt;$TAG_PREFIX ([$TAG_FORMAT]*)\&gt;","<$TAG_PREFIX \\1>",$$tmp);
 else $val_text = $$tmp;
 }

 if ($type_id == 22) {
 $tmp = "p".$pid."_a";
 global $$tmp;
 if ($$tmp) {
 $val_text = $$tmp;
 } else $skipupdate = true;
 }

 
 if ($type_id == 4) {
 
 $tmp = "p".$pid."_a";
 global $$tmp;
 $val_a = $$tmp;

 
 $tmp = "p".$pid."_b";
 global $$tmp;
 $val_b = $$tmp;

 
 $tmp = "p".$pid."_c";
 global $$tmp;
 $val_c = $$tmp;
 if ($val_c == "a") {
 $val_ref = $val_a;
 $info = 1;
 }
 if ($val_c == "b") {
 $val_text = $val_b;
 $info = 0;
 }

 
 if ($info == 1 && !empty($val_ref)) {
 $page = new CNPageObject($val_ref);
 $val_ref = $page->getMasterId();
 }

 
 if (empty($val_ref) && empty($val_text) && $required) {
 $ERROR = "p".$pid."_".$val_c;
 return false;
 }
 }

 
 if ($type_id == 5) {
 $tmp = "p".$pid."_a";
 global $$tmp;
 $val_ref = $$tmp;
 }

 
 if ($type_id == 6) {
 $tmp = "p".$pid."_a";
 global $$tmp;
 $val_ref = $$tmp;

 $image = new CNImageObject($val_ref);
 $val_ref = $image->getMasterId();
 }

 

 
 if ($type_id == 8 || $type_id == 14 || $type_id == 38 ) {
 $tmp = "p".$pid."_a";
 global $$tmp;
 $val_ref = $$tmp;

 $file = new CNFileObject($val_ref);
 $val_ref = $file->getMasterId();
 }

 
 if ($type_id == 13) {
 $tmp = "p".$pid."_b";
 global $$tmp;
 $val_text = $$tmp;
 $tmp = "p".$pid."_c";
 global $$tmp;
 $info = $$tmp;
 }

 
 if ($type_id == 25 || $type_id == 39 ) {
 $tmp = "p".$pid."_a";
 global $$tmp;
 $val_ref = $$tmp;

 $folder = new CNFolderObject($val_ref);
 $val_ref = $folder->getMasterId();
 }

 
 if ($type_id == 23) {
 $tmp = "p".$pid."_a";
 global $$tmp;
 $cols = $$tmp;
 $tmp = "p".$pid."_b";
 global $$tmp;
 $rows = $$tmp;
 $tmp = "p".$pid."_c";
 global $$tmp;
 $info = $$tmp;
 $params[0] = $cols;
 $params[1] = $rows;

 
 if ($type != "construct") {

 if ($type == "content") $_owner = "content_id";
 if ($type == "template") $_owner = "template_id";
 if ($type == "template") $sql = "SELECT name, $_owner, pub FROM $sqlpart WHERE id = ".sqlf_tl_num($tid);
 else $sql = "SELECT name, $_owner FROM $sqlpart WHERE id = ".sqlf_tl_num($tid);
 $rs = query($sql);
 $_tname = $rs["arr"][0]["name"];
 $_pub = $rs["arr"][0]["pub"];
 if (!$_pub) $_pub = 0;
 if ($O_TYPE == "obj") {
 list($obj_id,$obj_type) = each($O_ID);
 $sqlwhere = "obj_id = ".sqlf_tl_num($obj_id)." AND obj_type = ".sqlf_tl_num($obj_type);
 } else $sqlwhere = sqlf_name($O_TYPE)."_id = ".sqlf_tl_num($O_ID);
 
 $sql = "SELECT id FROM part WHERE construct_id = ".sqlf_tl_num($cid)." AND part.keyword LIKE 'tr.%'";
 $rs = query($sql);
 
 if (!$rs["num"]) $rs["arr"] = array();
 while (list($key,$val) = each($rs["arr"])) {
 $tr_parts[$val["id"]] = true;
 }
 $sql = "SELECT id FROM part WHERE construct_id = ".sqlf_tl_num($cid)." AND part.keyword LIKE 'td.%'";
 $rs = query($sql);
 
 while (list($key,$val) = each($rs["arr"])) {
 $td_parts[$val["id"]] = true;
 }
 
 $sql = "SELECT id FROM part WHERE construct_id = ".sqlf_tl_num($cid)." AND type_id = 23";
 $rs = query($sql);
 $table_part = $rs["arr"][0]["id"];
 $td_parts[$table_part] = true;
 $tr_parts[$table_part] = true;
 for ($r = 1; $r <= $rows; $r++) {
 
 $sql = "SELECT id FROM $sqlpart WHERE name = '".sqlf_escaped("$_tname.$r.style")."' AND $sqlwhere";
 $rs = query($sql);
 if ($rs["num"] == 0) {
 tag_create("$_tname.$r.style",$O_ID,$O_TYPE,$cid,$_pub,3,$tid,$tr_parts);
 }
 for ($c = 1; $c <= $cols; $c++) {
 $_cellname = $_tname.".".chr($c+64).$r;
 
 $sql = "SELECT id FROM $sqlpart WHERE name = '".sqlf_escaped($_cellname)."' AND $sqlwhere";
 $rs = query($sql);
 if ($rs["num"] == 0) {
 tag_create($_cellname,$O_ID,$O_TYPE,$info,$_pub,3,$tid);
 }
 
 $sql = "SELECT id FROM $sqlpart WHERE name = '".sqlf_escaped("$_cellname.style")."' AND $sqlwhere";
 $rs = query($sql);
 if ($rs["num"] == 0) {
 tag_create("$_cellname.style", $O_ID, $O_TYPE, $cid, $_pub, 3, $tid, $td_parts);
 }
 }
 }

 }

 $val_text = implode(";",$params);
 }

 
 if ($type_id == 11 || $type_id == 20) {
 $tmp = "p".$pid."_a";
 global $$tmp;
 $val_text = ${$tmp}[0];
 $tmp2 = $$tmp;
 $tmp2 = substr($tmp2,1);
 $val_ref = substr($tmp2,0,strpos($tmp2,"-"));
 $info = substr($tmp2,strpos($tmp2,"-")+1);

 
 if ($type_id == 11) {
 
 
 $page = new CNPageObject($info);
 $info = $page->getMasterId();
 $masterPage = new CNPageObject($info);

 if ($page->getID() != $masterPage->getID()) {
 if ($val_text == 'p') {
 
 
 $rs = query("SELECT id FROM contenttag WHERE content_id = ".sql_num($masterPage->getFieldValue("content_id")).
 " AND name = (SELECT name FROM contenttag WHERE id = ".sql_num($val_ref).")");
 if ($rs["num"] > 0) {
 $val_ref = $rs["arr"][0]["id"];
 }
 } else {
 
 
 $rs = query("SELECT id FROM templatetag WHERE template_id = ".sql_num($masterPage->getFieldValue("template_id")).
 " AND name = (SELECT name FROM templatetag WHERE id = ".sql_num($val_ref).")");
 if ($rs["num"] > 0) {
 $val_Ref = $rs["arr"][0]["id"];
 }
 }
 }
 } else {
 
 
 $template = new CNTemplateObject($info);
 $info = $template->getMasterId();
 $masterTemplate = new CNTemplateObject($info);

 if ($template->getID() != $masterTemplate->getID()) {
 $rs = query("SELECT id FROM templatetag WHERE template_id = ".sql_num($masterTemplate->getID()).
 " AND name = (SELECT name FROM templatetag WHERE id = ".sql_num($val_ref).")");
 if ($rs["num"] > 0) {
 $val_ref = $rs["arr"][0]["id"];
 }
 }
 }
 }

 
 if ($type_id == 12) {












 $tmp = "p".$pid."_a";
 global $$tmp;
 $cols = $$tmp;
 $tmp = "p".$pid."_b";
 global $$tmp;
 $rows = $$tmp;
 $tmp = "p".$pid."_c";
 global $$tmp;
 $th = $$tmp;
 $tmp = "p".$pid."_d";
 global $$tmp;
 $ctd = $$tmp;
 $tmp = "p".$pid."_e";
 global $$tmp;
 $cth = $$tmp;
 $tmp = "p".$pid."_f";
 global $$tmp;
 $f_td_ev = $$tmp;
 $tmp = "p".$pid."_g";
 global $$tmp;
 $f_td_odd = $$tmp;
 $tmp = "p".$pid."_h";
 global $$tmp;
 $f_th = $$tmp;
 $tmp = "p".$pid."_i";
 global $$tmp;
 $f_table = $$tmp;

 $sql = "SELECT count(*) AS c FROM contenttable WHERE ".$sqlpart."_id = ".sqlf_tl_num($tid)." AND part_id = ".sqlf_tl_num($pid);
 $rs = query($sql);
 if ($rs["arr"][0]["c"] == 0) {
 $sql = "INSERT INTO contenttable (".$sqlpart."_id, part_id) VALUES (".sqlf_tl_num($tid).",".sqlf_tl_num($pid).")";
 query($sql);
 }

 if (!$th) $th = 0;

 if ($ctd < 1) $ctd = 1;
 if ($cth < 1) $cth = 1;
 if (!$tid) die("part_update: table: sqlpart($sqlpart) invalid tid($tid)");
 $sql = "UPDATE contenttable SET
th = ".sqlf_tl_num($th).", td_f_even = '".sqlf_escaped($f_td_ev)."', td_f_odd = '".sqlf_escaped($f_td_odd)."', th_f = '".sqlf_escaped($f_th)."', td_type = ".sqlf_tl_num($ctd).", th_type = ".sqlf_tl_num($cth).", table_f = '".sqlf_escaped($f_table)."'
WHERE ".$sqlpart."_id = ".sqlf_tl_num($tid)." AND part_id = ".sqlf_tl_num($pid);
 query($sql);
 

 $params[0] = $cols;
 $params[1] = $rows;

 if ($type == "content") $_owner = "content_id";
 if ($type == "template") $_owner = "template_id";
 if ($type == "construct") $_owner = "template_id";
 if ($type == "template") $sql = "SELECT name, $_owner, pub FROM $sqlpart WHERE id = ".sqlf_tl_num($tid);
 else if ($type == "construct") $sql = "SELECT name, $_owner FROM $sqlpart WHERE id = 0 AND templatetag_id = 0 AND globaltag_id=0 AND objtag_id = 0"; 
 else $sql = "SELECT name, $_owner FROM $sqlpart WHERE id = ".sqlf_tl_num($tid);
 $rs = query($sql);
 $_tname = $rs["arr"][0]["name"];
 $_owner_id = $rs["arr"][0][$_owner];
 $_pub = $rs["arr"][0]["pub"];
 if (!$_pub) $_pub = 0;

 
 if ($th) $_r = 0;
 else $_r = 1;
 for ($r = $_r; $r <= $rows; $r++) {
 for ($c = 1; $c <= $cols; $c++) {
 $_cellname = $_tname."_".$r."_".$c;
 $sql = "SELECT construct_id, id FROM $sqlpart WHERE name = '".sqlf_escaped($_cellname)."' AND $_owner = ".sqlf_tl_num($_owner_id);
 $rs = query($sql);
 if ($r == 0) $constr = $cth;
 else $constr = $ctd;
 if (!$rs["arr"]) tag_create($_cellname,$_owner_id,$type,$constr,$_pub);
 else if ($rs["arr"][0]["construct_id"] != $constr) {
 $sql = "DELETE FROM value WHERE ".$sqlpart."_id = ".sqlf_tl_num($rs["arr"][0]["id"]);
 query($sql);
 $sql = "UPDATE $sqlpart SET construct_id = ".sqlf_tl_num($constr)." WHERE id = ".sqlf_tl_num($rs["arr"][0]["id"]);
 query($sql);
 }
 }
 }

 $val_text = implode(";",$params);
 }

 
 if ($type_id == 15 || $type_id == 16 || $type_id == 17) {
 $tmp = "p".$pid."_a";
 global $$tmp;
 $val_text = $$tmp;
 if ($type_id == 15) {
 $tmp = "p".$pid."_b";
 global $$tmp;
 $info = $$tmp;
 }
 }

 if ($type_id == 18 || $type_id == 19 || $type_id == 24) {
 if ($type_id == 18) {
 $size[0] = 70;
 $size[1] = 120;
 $size[2] = 180;
 }
 if ($type_id == 19) {
 $size[0] = 110;
 $size[1] = 160;
 $size[2] = 220;
 }
 if ($type_id == 24) {
 $size["zellehell"] = "zellehell";
 $size["zelledunkel"] = "zelledunkel";
 $size["headernegativ"] = "headernegativ";
 $size["farblos"] = " ";
 }
 $tmp = "p".$pid."_a";
 global $$tmp;
 $val_text = $size[$$tmp];
 }

 if ($type_id == 29 || $type_id == 30) {
 $sql = "SELECT info_int, info_text FROM part WHERE id = ".sqlf_tl_num($pid);
 $rs = query($sql, true);
 $info_int = $rs["arr"][0]["info_int"];
 $info_text = $rs["arr"][0]["info_text"];
 $tmp = "p".$pid."_a";
 $session = $tmp."_SESSION";
 global $$tmp, $$session;
 if ( !is_array( $$tmp ) )
 $sourceList = array( $$tmp );
 else
 $sourceList = $$tmp;
 
 if ( $type_id == 30 ) {
 
 
 
 
 $keepSet = array_diff( ${$session}["sel"], ${$session}["allkeys"] );
 if ( count($keepSet) > 0 && $FEATURE["dskeepselectvalues"] ) {
 if ( count($sourceList) > 0 ) {
 $sourceList = array_merge( $sourceList, $keepSet );
 } else {
 $sourceList = $keepSet;
 }
 } 
 }
 mysession_var_unreg( $session );
 
 $run_tmp = $sourceList;
 $sourceList = array();
 
 foreach ( $run_tmp as $run_val ) {
 if ( strlen($run_val) > 0 ) {
 $sourceList[] = $run_val; 
 }
 }

 $val_text = implode( "|-|", $sourceList );
 $val_ref = $info_int;
 mysession_var_unreg( $session );
 }

 if ($type_id == 31) {
 $tmp = "p".$pid."_a";
 global $$tmp;
 $val_text = $$tmp;
 }
 
 if ( $type_id == 32 ) {
 $tmp = "p".$pid."_genDatasourceWizard";
 global $$tmp;
 $val_ref = $$tmp;
 }

 if (!$val_ref) $val_ref = 0;
 if (!$info) $info = 0;
 
 $sql = "SELECT keyword FROM part WHERE id = ".sqlf_tl_num($pid);
 $rs = query($sql);
 if ($rs["num"]) {
 if ($rs["arr"][0]["keyword"] == "td.header" && !$val_text) $val_text = 0;
 }
 
 $forceClear = false;
 if ($FEATURE["clear_tablestyles"]) {
 $keyword = $rs["arr"][0]["keyword"];
 if (substr($keyword, 0, 6) == "table." || substr($keyword, 0, 7) == "table+.") $forceClear = true;
 else {
 
 $tmp = "p".$pid."_cl";
 global $$tmp;
 if ($$tmp) {
 $forceClear = true;
 $val_ref = 0;
 $val_text = "";
 $info = 0;
 }
 }
 }
 
 if ($TABLE_TAG && ((!strlen($val_text) && !$val_ref && !$info) || $val_text == "-9999") && !$forceClear) $skipupdate = true;
 
 if (!$skipupdate) {
 if ($FEATURE["validation"]) {
 $requ = new TagPartValidationRequest();
 $resp = $requ->validateTagPart($val_text, $pid);
 if ( ! $FEATURE["ignoreAntiSamyErrors"] && $resp->isError() ) {
 set_global_validation_result($resp);
 return false;
 }
 $val_text = $resp->getCleanMarkup();
 }
 $hasChanged = cmd_update_value( $val_text, $val_ref, $info, $type, $tid, FALSE, $pid, $static, false, $changePageStatus );
 }
 else
 $hasChanged = false;

 if ( $returnFalseIfNotChanged )
 return $hasChanged;
 else
 return true;

}
?>
