<?
define("PERM_TASK_LIST", 10);

Guifactory::setMainGui("main");

node_include("task_schedule_func");
$NODERELATED[$DO] = getTaskRelated($DO);


$LAST_TASK_VIEW = 2;
load_menu( 862, $T_TASKADMIN, 0, $DIC[1386] );

node_class( "commandaction" );
node_class( "resultsetformatter" );
node_class( "userformatter" );
node_class( "dateformatter" );
node_include( "task_schedule_func" );

class CommandFormatter extends ResultsetFormatter {
 
 function format( $rs )
 {
 return translateCommand( $rs["id"] ); 
 }

}


if ( perm( $USER_ID, T_TASKADMIN, "", PERM_TASK_LIST) == 1 ) {
 $select = "task.cdate as cdate, task.creator as creator, task.edate as edate, task.editor as editor, ".
 "task.id as id, task.tasktemplate_id, task.name as taskname, tasktemplate.name as templatename";
 $from = "task, tasktemplate";
 $where = "task.tasktemplate_id=tasktemplate.id";
 $group_by = "";
} else {
 $select = "task.cdate as cdate, task.creator as creator, task.edate as edate, task.editor as editor, ".
 "task.id as id, task.tasktemplate_id, task.name as taskname, tasktemplate.name as templatename";
 $from = "task, tasktemplate, perm, user_group";
 $where = "user_group.user_id = ".sqlf_tl_num($USER_ID)." AND perm.usergroup_id = user_group.usergroup_id AND task.id = o_id AND o_type = ".sqlf_tl_num(T_TASK)." AND perm LIKE \"1%\"";
 $where .= " AND task.tasktemplate_id = tasktemplate.id";
 $group_by = "o_id";
}

$ds = new SQLDatasource( "taskds", $select, $from, $where, $group_by );
$ds->setDBHandle( $DB );
$ds->addColumn( "lnkname", $DIC[1466], true, "task.name", "task.name" );
$ds->addColumn( "command", $DIC[1468], false, false );
$ds->addColumn( "templatename", $DIC[1578], true, "tasktemplate.name", "tasktemplate.name" );

$ds->makeLink( "lnkname", "taskname", "do=861", "list", "id", "id" );
$ds->addFormatter( "command", new CommandFormatter() ); 
$ds->addFormatter( "cname", new UserFormatter( "creator", USERINFO_NAME ) );
$ds->addFormatter( "fcdate", new DateFormatter( "cdate" ) );
$ds->addFormatter( "ename", new UserFormatter( "editor", USERINFO_NAME ) );
$ds->addFormatter( "fedate", new DateFormatter( "edate" ) );
$ds->setAss( "<b>$DIC[1463]</b><br><br><b>$DIC[1466]:</b> \$taskname<br>".
 "<b>$DIC[1462]:</b> \$templatename<br>".
 "<b>$DIC[845]:</b><br>\$fcdate (\$cname)<br>".
 "<b>$DIC[259]:</b><br>\$fedate (\$ename)" );
if (perm( $USER_ID, T_TASKADMIN, "", 11) ) {
 $ds->addAction( new CommandAction( $ICO_DELETE, "del", $DIC[18], "cmd_task_del" ) );
}


$list = new ItemList3("tasks", $ds );
$list->setShowInfo( true );

?>
