<?


function has_inboxtoemail_activated( $user ) {
 $sql = "SELECT inboxtoemail FROM systemuser WHERE id = '".sqlf_escaped($user)."';";
 $rs = query($sql);
 return $rs['arr'][0]['inboxtoemail'] ? TRUE : FALSE;
}



 
function msg_to_super_admin_group($msg, $from, $instanttime = 0) {
 foreach (get_users_in_group(NODE_SUPER_ADMIN_GROUP) as $user_id) {
 msg($msg, $user_id, $from, $instanttime);
 }
 return;
}












function msg_to_editor($msg, $to, $from, $instanttime = 0) {
 if (-1 == $to) {
 return msg_to_super_admin_group($msg, $from, $instanttime);
 } else {
 return msg($msg, $to, $from, $instanttime);
 }
}







function msg_interactive($msg, $to, $from, $instanttime = 0) {
 return msg_checked($msg, $to, $from, $instanttime);
}









function msg_checked($msg, $to, $from, $instanttime = 0) {
 reset_global_validation_result();

 $resp = validate_input('userMessage', $msg, new InputValidationRequest());
 set_global_validation_result($resp);
 $msg = $resp->getCleanMarkup();
 if ($resp->isError()) {
 return false;
 }

 return msg($msg, $to, $from, $instanttime);
}










function msg($msg, $to, $from, $instanttime = 0) {
 global $TIME, $FEATURE, $DIC, $MODULE;

 if ($instanttime == "") {
 $instanttime = 0;
 }
 
 
 if ($to == -1) {
 $allusers = user_get_visibleuserswithname();
 while (list($k,$user) = each($allusers)) {
 if ($user["id"] > -1) {
 msg($msg, $user["id"], $from, $instanttime);
 }
 }
 return;
 }

 $msg = str_replace("\r","",$msg);
 
 if ( $to && $from ) {
 $sql = "INSERT INTO msg (to_user_id, from_user_id, msg, oldmsg, timestamp, instanttime) VALUES " .
 "(".sqlf_tl_num($to).", ".sqlf_tl_num($from).", '".sqlslashes($msg)."', 0, ".sqlf_tl_num($TIME).", ".sqlf_tl_num($instanttime).")";
 $rs = query($sql);
 $iid = $rs["iid"];

 if( $FEATURE['log_inbox_create'] ) {
 logcmd( W_INBOXCREATE, T_INBOX_MSG, $iid, 0 );
 }

 
 if ($instanttime == 0 && ($FEATURE["inbox_to_email"] || ($FEATURE['inbox_to_email_optional'] && has_inboxtoemail_activated( $to )))) {
 $sql = "SELECT email, firstname, lastname FROM systemuser WHERE id = ".sqlf_tl_num($from);
 $rs = query($sql);

 $username = $rs["arr"][0]["lastname"]." ".$rs["arr"][0]["firstname"];
 $email = $rs["arr"][0]["email"];

 $sql = "SELECT email FROM systemuser WHERE id = ".sqlf_tl_num($to);
 $rs = query($sql);


 if ($rs["arr"][0]["email"]) {

 if ($email) {
 $header = "From: $email";

 if ($FEATURE["UTF8"])
 $header .= "\r\n";
 }

 else 
 $header = "";

 $subject = $DIC[1264]." $username";

 if ($FEATURE["UTF8"]) {
 $header .= "Content-Type: text/plain; charset=UTF-8\r\nContent-Transfer-Encoding: 8bit";
 $subject = "=?UTF-8?B?" . base64_encode($subject) . "?=";
 }
 
 mail($rs["arr"][0]["email"], $subject, get_msg($iid,"text")."\n--\n".$DIC[1414], $header);
 }
 }
 }
 return $iid;
}


function get_msg($id, $type) {
 global $MODULE, $PARSE_MSG, $STAG;

 if ($type != "text" && $type != "html" && $type != "msg") halt(7, "get_msg: wrong type ($type)");

 $sql = "SELECT msg FROM msg WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 if ($rs["num"] == 0) return "";
 $msg = $rs["arr"][0]["msg"];
 
 if (is_array($PARSE_MSG)) {
 reset($PARSE_MSG);
 while (list($mod, $func) = each($PARSE_MSG)) {
 $msg = $func($mod, $msg, $type);
 }
 }
 
 
 if ($type == "text") {
 $msg = eregi_replace("<br( /)?>\n","\n",$msg);
 $msg = str_replace("<br( /)?>", "\n", $msg);
 } else {
 $msg = str_replace("<br( /)?>\n","<br>",$msg);
 $msg = str_replace("\n","<br>",$msg);
 }

 $msg = str_replace("#STAG#",$STAG,$msg);

 return $msg;
}

function msg_invalid_link($page_id, $editor, $user_id, $status) {
 global $FEATURE, $STAG;

 if (!$FEATURE["invalidpageurlmsg"] && $user_id != 0) return;

 $page = get_pageinfo($page_id);

 if ($status == "status3") $msg = i18n("taken offline"); 
 if ($status == "del") $msg = i18n("deleted_lc"); 

 

 $sql = "SELECT contenttag.content_id, contenttag.name FROM contenttag, value, part WHERE
contenttag.id = value.contenttag_id AND value.part_id = part.id AND part.type_id = 4 AND
value.value_ref = ".sqlf_tl_num($page_id)." GROUP BY contenttag.content_id, contenttag.name";
 $rs = query($sql);
 if ($rs["num"] > 0) {
 while(list($key,$val) = each($rs["arr"])) {
 $sql = "SELECT page.id pid, folder.id fid, page.name pname, folder.name fname, nodefolder.name nname, page.editor"
 . " FROM page, folder, folder nodefolder" 
 . " WHERE content_id = ".sqlf_tl_num($val["content_id"])
 . " AND page.id <> ".sqlf_tl_num($page_id)
 . " AND page.folder_id = folder.id"
 . " AND nodefolder.node_id = folder.node_id"
 . " AND nodefolder.mother = 0";
 $rs2 = query($sql);
 $tmp = $rs2["arr"][0];
 if ( $rs2["num"] > 0 ) {
 $tmplink = "#STAG#&do=14002&PAGE_ID=".$tmp["pid"]."&FOLDER_ID=".$tmp["fid"];
 if ($FEATURE["force_node2"]) {
 $_message = i18n( "notification.linkfrompage.invalid.atleastone", 0, $tmp["pname"], $tmp["pid"], $tmp["fname"], $tmp["nname"], $page["name"], $msg);
 
 $iid = msg_to_editor($_message,$tmp["editor"],$user_id);
 $notified[] = array('message' => $_message,
 'message_id' => $iid,
 'editor' => $tmp["editor"],
 'user_id' => $user_id,
 'page_id' => $tmp["pid"]
 );
 } else {
 $link_folder = get_folderinfo($tmp["fid"], true);
 $target_folder = get_folderinfo($page["folder_id"], true);
 $link_page_path = $link_folder["fullpath"]["name"] . '/' . $tmp["pname"];
 $target_page_path = $target_folder["fullpath"]["name"] . '/' . $page["name"];
 $_message = i18n("notification.linkfrompage.invalid", 0, $val["name"], $link_page_path, $tmp["pid"], $target_page_path, $page["id"], $msg );
 $_subject = i18n( "Invalid link in page \"{0}\"", 0, $tmp["pname"] );
 $iid = msg_to_editor($_message,$tmp["editor"],$user_id);
 $notified[] = array('message' => $_message,
 'subject' => $_subject,
 'message_id' => $iid,
 'editor' => $tmp["editor"],
 'user_id' => $user_id,
 'page_id' => $tmp["pid"]
 );
 }
 }
 }
 }

 $sql = "SELECT DISTINCT templatetag.template_id FROM templatetag, value, part WHERE
templatetag.id = value.templatetag_id AND value.part_id = part.id AND part.type_id = 4 AND
value.value_ref = ".sqlf_tl_num($page_id);
 $rs = query($sql);
 if ($rs["num"] > 0) {
 while(list($key,$val) = each($rs["arr"])) {
 $template = get_templateinfo($val["template_id"]);
 $_message = i18n( "notification.linkfromtemplate.invalid.atleastone", 0, $template["name"], $template["id"], $page["name"], $msg );
 msg_to_editor($_message,$template["editor"],$user_id);
 }
 }
 
 return $notified; 
}

function check_msg_num ($user_id) {

 $sql = 'SELECT id FROM msg WHERE to_user_id = "'.sqlf_escaped($user_id).'" AND oldmsg = 0';
 $rs = query($sql);
 $messages = $rs["num"];
 return $messages;
}





function checkInstantMessages($user_id) {
 $rs = query("SELECT msg.*, CONCAT(s.firstname, ' ', s.lastname) 'from' FROM msg LEFT JOIN systemuser s on msg.from_user_id = s.id WHERE to_user_id = ".sqlf_tl_num($user_id)." AND (timestamp + instanttime * 60) > UNIX_TIMESTAMP() AND oldmsg = 0 ORDER BY id ASC limit 1");
 if ($rs["num"] == 1) {
 return array(
 "id" => $rs["arr"][0]["id"],
 "from" => $rs['arr'][0]['from'],
 "msg" => $rs['arr'][0]['msg']
 );
 }
 return false;
}






function msg_assert_destination($user_id, $msg_id) {
 $rs = query("SELECT id FROM msg"
 . " WHERE id = ".sql_num($msg_id)
 . "   AND to_user_id = ".sql_num($user_id));
 if ( ! $rs["num"]) {
 halt(3, "User {$user_id} requested access"
 . " to message {$msg_id} which isn't destined to him");
 }
}
?>
