alter table regex add index (name_id);
alter table regex add index (desc_id);
optimize table regex;

alter table tree add index (mother);
alter table tree add index (type_id);
optimize table tree;

alter table perm add index (usergroup_id);
alter table perm add index (o_id);
alter table perm add index (perm);
alter table perm add index (o_type, usergroup_id);
alter table perm add index(usergroup_id,o_type,o_id);
optimize table perm;

alter table usergroup add index (mother);
optimize table usergroup;

alter table user_group add index (user_id);
alter table user_group add index (usergroup_id);
alter table user_group add index(usergroup_id,user_id);
optimize table user_group;

alter table systemsession add index (sid);
alter table systemsession add index (user_id);
optimize table systemsession;


alter table dicuser add index (value(40), language_id);
alter table dicuser add index (output_id, language_id);
alter table dicuser add index (output_id);
optimize table dicuser;
alter table msg add index (from_user_id);
alter table msg add index (to_user_id);
optimize table msg;

alter table logcmd add index(user_id);
alter table logcmd add index(o_type);
alter table logcmd add index(user_id,o_type);
alter table logcmd add index(o_id);
alter table logcmd add index (o_id,o_type,timestamp,cmd_desc_id);
optimize table logcmd;

alter table imgresizecache add index(filename);
optimize table imgresizecache;

alter table dependencymap add index (mod_type,mod_id);
alter table dependencymap add index (dep_type,dep_id);
optimize table dependencymap;

alter table loginfo add index(logevent_id);
optimize table loginfo;

alter table nodecache_event add index(nodecache_id,o_id,o_type,eventtype); 
optimize table nodecache_event;

alter table jobrun add index(job_id,valid);
optimize table jobrun;
